module ServiceLayerRest
  module Constants
    # Keys for hashes from the server and to the client
    STATUS_KEY = "status"
    DATA_KEY = "data"
    SOURCE_KEY = "source"
    SOURCE_DETAILS_KEY = "source_details"

    MANDANT_ID_KEY = "mandant_id"
    MANDANTID_KEY = "mandantid"
    AUTHTYPE_KEY = "authtype"
    USERDATA_KEY = "user_data"

    ID_SERVER_KEY = "iD"
    ID_CLIENT_KEY = "id"
    PLANAREA_ID_KEY = "iD_PLANBEREICH"

    VORNAME_KEY = "vorname"
    NACHNAME_KEY = "name"

    MIT_LIST_KEY = "mit_list"
    MIT_LIST_TODAY_KEY = "mit_list_today"
    FERIENTAGE_KEY = "ferientage"
    PLANBEREICHE_KEY = "planbereiche"
    ITEMS_KEY = "items"
    TKS_LIST_KEY = "tKS_List"
    DATUM_KEY = "datum"
    ERSTELLT_AM_KEY = "eRSTELLT_AM"
    GEANDERT_AM_KEY = "gEAENDERT_AM"
    ZEITSTEMPEL_SERVER_KEY = "zEITSTEMPEL"
    ZEITSTEMPEL_CLIENT_KEY = "zeitstempel"
    ID_STATION_KEY = "iD_Station"
    PLANBEREICH_KEY = "planbereich"
    PLANSTATUS_KEY = "planstatus"
    FERIEN_KEY = "ferien"
    IS_FEIERTAG_KEY = "isFeiertag"
    FEIERTAG_DEF_KEY = "feiertagDef"
    SERVICES_KEY = "services"
    STANDBYS_KEY = "standbys"
    STATES_KEY = "states"
    COLOR_INFOS_KEY = "color_infos"
    IS_HOLIDAY_DAY_KEY = "is_holiday_day"
    HOLIDAY_DAY_REF_KEY = "holiday_day_ref"
    TEL_LIST_CLIENT_KEY = "tel_list"
    DAY_FROM_KEY = "from"
    DAY_TO_KEY = "to"
    FULL_DAY_STATE_KEY = "fullDayState"
    OVERNIGHT_KEY = "overNight"
    PLANAREAS_KEY = "planareas"
    WARNING_LEFT_KEY = "warningLeft"
    WARNING_RIGHT_KEY = "warningRight"
    FARBINFO_ITEMLIST_KEY = "farbInfo_ItemList"
    HEADER_DATALIST_KEY = "header_DataList"
    DT_HEADER_VON_KEY = "dt_Header_von"
    DT_HEADER_BIS_KEY = "dt_Header_bis"
    B_HEADER_BESTAETIGT_KEY = "bHeaderBestaetigt"
    PLAN_NR_SERVER_KEY = "planNr"
    DAILY_DATA_KEY = "daily_data"
    INFORMATIONS_KEY = "informations"
    HEADER_KEY = "header"
    MONTH_CONFIRMATION_KEY = "month_confirmation"
    CONFIRMED_MONTH_KEY = "confirmed_month"
    PLAN_NR_CLIENT_KEY = "plan_nr"
    TAGESELEMENT_KATEGORIE_KEY = "tageselement_Kategorie"
    TYPE_KEY = "type"
    ITEM_KEY = "item"
    STATE_TYPE_KEY = "state_type"
    BIS_KEY = "bis"
    VON_KEY = "von"
    REFERENZ_TAGESDATEN_KEY = "referenzDefinition"
    BEZEICHNUNG_KEY = "bezeichnung"
    TEL_DET_LIST_KEY = "tELDET_List"
    TEL_LIST_SERVER_KEY = "tEL_List"
    KUERZEL_KEY = "kuerzel"
    KUERZEL_IST_KEY = "kUERZEL_IST"
    FIRSTNAME_KEY = "firstname"
    LASTNAME_KEY = "lastname"
    DAILY_DATA_ALT_KEY = "dailyData"
    NAME_KEY = "name"
    STATUS_HOUR_KEY = "statusHour"
    DIENSTE_DEF_LIST_KEY = "dienste_def_list"
    BEREIT_DEF_LIST_KEY = "bereit_def_list"
    STATUS_DEF_LIST_KEY = "status_def_list"
    PRINT_KUERZEL_KEY = "printKuerzel"
    REST_TIME_KEY = "rest_time"
    LAST_CHANGE_DURATION_KEY = "last_change_duration"
    BALANCE_WORKTIME_KEY = "balance_work_time"
    LAST_CHANGE_KEY = "last_change"
    TITLE_KEY = "title"
    VALUE_KEY = "value"
    DETAILS_KEY = "details"
    URLAUB_DATALIST_KEY = "urlaub_DataList"
    GENOMMEN_KEY = "genommen"
    ANSPRUCH_KEY = "anspruch"
    JAHR_KEY = "jahr"
    HOLIDAYS_KEY = "holidays"
    SOLL_KEY = "soll"
    IST_KEY = "ist"
    TIMESHEET_KEY = "timesheet"
    DATE_KEY = "date"
    DUTY_KEY = "duty"
    ANZAHL_TEL_DET_KEY ="anzahl_TELDET"

    # Titles and texts for the informations
    REST_TIME_TITLE = "Restdienstzeit heute"
    BALANCE_WORKTIME_TITLE = "Saldo Arbeitszeit"
    NO_LAST_CHANGE_DURATION_TITLE = "In diesem Monat gab es keine Änderungen am Dienstplan."
    NO_LAST_CHANGES_DURATION_TITLE = "keine Änderung am Dienstplan."
    LAST_CHANGE_ON_TITLE = "Letzte Änderung am"
    READY = "fertig"
    FREI = "frei"
    DAYS = "Tagen"
    SEIT = "Seit"
    YESTERDAY = "gestern"
    THE_DAY_BEFORE_YESTERDAY = "vorgestern"
    AVAILABLE_HOLIDAY_DAYS = "Verfügbare Urlaubstage"

    # Types
    TYPE_SERVICE = "service"
    TYPE_STATE = "state"
    TYPE_STANDBY = "standby"

    TYPE_THREE_LINES = "three-lines"
    TYPE_BIG_VALUE = "big-value"
    TYPE_TEXT_ONLY = "text-only"

    # Tageselement Kategorien
    TAGESELEMENT_KATEGORIE_SERVICE = 1
    TAGESELEMENT_KATEGORIE_STANDBY = 2
    TAGESELEMENT_KATEGORIE_STANDBY_OPERATION = 3
    TAGESELEMENT_KATEGORIE_STATE = 5

    # Different states
    STATE_FULL = 0
    STATE_HOURLY_OVERLAPPING = 1
    STATE_HOURLY = 2

    # Some constants
    DATE_ZERO = "1899-12-30T00:00:00.000Z"
    DATE_FORMAT = "%d.%m.%Y"
    DATE_REVERSED_FORMAT = "%Y-%m-%d"
    TIME_FORMAT = "%H.%M.%S"
    STATE_FREE = "Frei"
    INVALID_PLANSTATE = 999

    # Requests
    CREATED_AT_KEY = "created_at"
    REQUEST_TYPE_ALL = "all"
    REQUEST_STATUS_NEW = 0
    REQUEST_STATUS_CANCELED = 99
    REQUEST_ID_KEY = "request_id"

    # Error messages
    ERROR_TEXT = "Fehler beim Abrufen"
    FROM_DETAIL_PLAN = "des Detailplan"
    FROM_YEAR_PLAN = "des Jahresplan"
    FROM_GROUP_PLAN = "des Gruppenplan"
    INVALID_DATA = "Struktur der Daten ist invalide."
    EMPTY_EMPLOYEES = "Mitarbeiterliste ist leer."
    EMPTY_DAILY_DATA = "Tageselemente sind leer."

    DELETE_SERVICES = "löschenden Dienste"
    DELETE_STANDBYS = "löschenden Bereitschaften"
    DELETE_STATES = "löschenden Status"
    FROM_DEFINITIONS = "der Definitionen"
    FROM_DETAILS = "der Tagesdatendetails"
    
    FROM_INFORMATIONS = "der Informationen"

    # Rights keys
    RIGHTS_USER_CONFIG_KEY = "userConfig"
    RIGHTS_FUNCTION_RIGHTS_KEY = "dictFunctionRights"
    RIGHTS_MAX_DAY_CHANGE_DUTY_KEY = "max_Tage_Change_Dienst"
    RIGHTS_MAX_DAY_CHANGE_STANDBY_KEY = "max_Tage_Change_Bereitschaft"
    RIGHTS_MAX_DAY_CHANGE_TIMESHEET_KEY = "max_Tage_Change_Stunden"

    RIGHTS_WORKFLOW_VACATION_KEY = "iD_Workflow_Urlaub"
    RIGHTS_WORKFLOW_BOOKING_CORRECTION_KEY = "iD_Workflow_Korrekturbuchung"
    RIGHTS_WORKFLOW_OVERTIME_REDUCTION_KEY = "iD_Workflow_Ueberzeitenabbau"
    RIGHTS_WORKFLOW_ILL_WITHOUT_DISABLEDKEY = "iD_Workflow_KrankOhneAU"

    RIGHTS_START_KEY = "start"
    RIGHTS_DUTY_INPUT_KEY = "dutyInput"
    RIGHTS_DUTY_WISH_KEY = "dutyWish"
    RIGHTS_STANDBY_INPUT_KEY = "standbyInput"
    RIGHTS_STANDBY_WISH_KEY = "standbyWish"
    RIGHTS_PLANAREA_VISIBLE_KEY = "planareaVisible"
    RIGHTS_CHANGE_APPROVED_DUTY_TOKENS_KEY = "changeApprovedDutyTokens"
    RIGHTS_CHANGE_APPROVED_STANDBY_TOKENS_KEY = "changeApprovedStandbyTokens"
    RIGHTS_WARNINGS_VISIBLE_KEY = "warningsVisible"
    RIGHTS_ONLY_APPROVED_DUTY_PLANS_VISIBLE_KEY = "onlyApprovedDutyPlansVisible"
    RIGHTS_TIMESHEET_KEY = "timesheet"
    RIGHTS_DAY_INSPECTOR_KEY = "dayInspector"
    RIGHTS_CUMULATION_KEY = "cumulation"
    RIGHTS_FUTURE_DISABLED_KEY = "futureDisabled"

    # Rights enum values
    RIGHTS_START = 11010000
    RIGHTS_DUTY_INPUT = 11020000
    RIGHTS_DUTY_WISH = 11030000
    RIGHTS_STANDBY_INPUT = 11040000
    RIGHTS_STANDBY_WISH = 11050000
    RIGHTS_PLANAREA_VISIBLE = 11060000
    RIGHTS_CHANGE_APPROVED_DUTY_TOKENS = 11070000
    RIGHTS_CHANGE_APPROVED_STANDBY_TOKENS = 11080000
    RIGHTS_WARNINGS_VISIBLE = 11090000
    RIGHTS_ONLY_APPROVED_DUTY_PLANS_VISIBLE = 11100000
    RIGHTS_TIMESHEET = 11110000
    RIGHTS_DAY_INSPECTOR = 11120000
    RIGHTS_CUMULATION = 11130000
    RIGHTS_FUTURE_DISABLED = 11140000

    # Vacation keys
    VACATION_SERVER_FULL_NIGHT_KEY = "voll_Nacht"
    VACATION_SERVER_FULL_SHIFT_KEY = "voll_Schicht"
    VACATION_SERVER_FULL_DISABILITY_KEY = "voll_Behinderung"
    VACATION_SERVER_FULL_OTHER_KEY = "voll_Sonstige"

    VACATION_SERVER_PARTIAL_PSYCHIATRY_KEY = "ant_Psych"
    VACATION_SERVER_PARTIAL_OTHER_1_KEY = "ant_Sonstige1"
    VACATION_SERVER_PARTIAL_OTHER_2_KEY = "ant_Sonstige2"
    VACATION_SERVER_PARTIAL_REASON_KEY = "zusatz_Grund" # TODO: Determine if this is REALLY the key for the partial reason.

    VACATION_SERVER_WHOLE_YEAR_KEY = "anspruch" # TODO: Just guessed. Need to determine if this is the correct key or not.
    VACATION_SERVER_WHOLE_PREVIOUS_YEAR_KEY = "rest_alt" # TODO: Just guessed. Need to determine if this is the correct key or not.
    VACATION_SERVER_WHOLE_EXTRA_KEY = "zusatz" # TODO: Just guessed. Need to determine if this is the correct key or not.
    VACATION_SERVER_WHOLE_CORRECTION_KEY = "korrektur" # TODO: Just guessed. Need to determine if this is the correct key or not.
    VACATION_SERVER_WHOLE_TAKEN_KEY = "genommen" # TODO: Just guessed. Need to determine if this is the correct key or not.
    VACATION_SERVER_WHOLE_PLANNED_KEY = "geplant" # TODO: Just guessed. Need to determine if this is the correct key or not.
    VACATION_SERVER_WHOLE_APPROVED_KEY = "genehmigterUrlaub" # TODO: Just guessed. Need to determine if this is the correct key or not.
    VACATION_SERVER_WHOLE_CARRYOVER_KEY = "uebertrag" # TODO: Just guessed. Need to determine if this is the correct key or not.
    VACATION_SERVER_WHOLE_COMMENT_KEY = "bemerkung" # TODO: Just guessed. Need to determine if this is the correct key or not.

    VACATION_SERVER_AVZ_CLAIM_KEY = "aV_Anspruch"
    VACATION_SERVER_AVZ_TAKEN_KEY = "aV_genommen"

    # Plan history process enum
    # TODO: This is purely fake data and may need to be changed when the server is ready. Note that the MyPEP client would need to be changed as well since it uses these enums.
    # TODO: Need to further determine if these are all possible enum values or not.
    PLAN_HISTORY_PROCESS_CONTROL_DISPLAY = 0
    PLAN_HISTORY_PROCESS_DETAIL_PLAN_NEXT_MONTH = 1
    PLAN_HISTORY_PROCESS_DETAIL_PLAN_PREVIOUS_MONTH = 2
    PLAN_HISTORY_PROCESS_DUTY_TOKEN_CHANGE = 3
    PLAN_HISTORY_PROCESS_BOOKING_LONGTERM_ACCOUNT = 4

    # Time booking
    TIME_BOOKING_TYPE_COMES = 0
    TIME_BOOKING_TYPE_LEAVES = 1

    TIME_BOOKING_KEY = "booking"
    TIME_BOOKING_BREAKS_KEY = "breaks"
    TIME_BOOKING_IS_DAY_CHECKED_KEY = "isDayChecked"
    TIME_BOOKING_BREAK_PLANNED_KEY = "planned"
    TIME_BOOKING_BREAK_TRACKED_KEY = "tracked"
  end
end
