# Aggregated Services for Applications

ServiceLayerRest::Engine.routes.draw do
    scope "/v1" do
        scope "/api" do
            scope "/my-pep" do
                scope "/detail_plan" do
                    get "/" => "my_pep#get_detail_plan"
                end
                scope "/informations" do
                    get "/" => "my_pep#get_informations"
                end
                scope "/year_plan" do
                    get "/" => "my_pep#get_year_plan"
                end
                scope "/group_plan" do
                    get "/" => "my_pep#get_group_plan"
                end
                scope "/daily_data_details" do
                    get "/" => "my_pep#get_daily_data_details"
                end  
                scope "/daily_data_duty_requests" do
                    put "/" => "my_pep#delete_daily_data_duty_requests" # Should be delete, but the framework doesn't allow it
                end
                scope "/definitions" do
                    get "/" => "my_pep#get_definitions"
                end   
                scope "/timesheet" do
                    get "/" => "my_pep#load_timesheet"
                    put "/" => "my_pep#update_timesheet"
                end   
                scope "/requests" do
                    get "/" => "my_pep#load_requests"
                    post "/" => "my_pep#create_request"
                    put "/cancel" => "my_pep#cancel_request"
                end
                scope "/vacation_account" do
                    get "/" => "my_pep#get_vacation_account"
                end
                scope "/plan_history" do
                    get "/" => "my_pep#get_plan_history"
                end
                scope "/time_bookings" do
                    get "/" => "my_pep#get_time_bookings"
                end
                get "annual_working_time_account" => "my_pep#get_annual_working_time_account"
            end
        end
    end
end
